"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getRoutes = getRoutes;
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectDestructuringEmpty2 = _interopRequireDefault(require("@babel/runtime/helpers/objectDestructuringEmpty"));

require("antd/lib/config-provider/style");

var _configProvider = _interopRequireDefault(require("antd/lib/config-provider"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _reactRouterDom = require("react-router-dom");

var _reactRedux = require("react-redux");

var _zh_CN = _interopRequireDefault(require("antd/lib/locale-provider/zh_CN"));

var _TabRouter = _interopRequireDefault(require("../TabRouter"));

var _state = require("../../utils/state");

var _utils = require("../../utils/utils");

var _path = require("../../utils/path");

var _history = _interopRequireDefault(require("../../modules/history"));

var _dec, _class, _dec2, _class2;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

/**
 * 路由组件
 */
var RouterMod =
/*#__PURE__*/
function (_PureComponent) {
  (0, _inherits2["default"])(RouterMod, _PureComponent);

  function RouterMod() {
    (0, _classCallCheck2["default"])(this, RouterMod);
    return (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(RouterMod).apply(this, arguments));
  }

  (0, _createClass2["default"])(RouterMod, [{
    key: "render",
    value: function render() {
      var props = this.props;
      return _react["default"].createElement(_reactRedux.Provider, {
        store: props.store
      }, _react["default"].createElement(_configProvider["default"], {
        locale: _zh_CN["default"]
      }, _react["default"].createElement(_react["default"].Fragment, null, _react["default"].createElement(RouterContent, {
        defaultRoutes: props.routes
      }), _react["default"].createElement(Fragment, null))));
    }
  }]);
  return RouterMod;
}(_react.PureComponent);
/**
 * 路由内容
 */


exports["default"] = RouterMod;
var RouterContent = (_dec = (0, _state.reduxConnect)(function (_ref) {
  (0, _objectDestructuringEmpty2["default"])(_ref);
  return {
    routes: (0, _state.getFrameState)().routes,
    isTabRouter: (0, _state.getFrameState)().isTabRouter
  };
}), _dec(_class =
/*#__PURE__*/
function (_PureComponent2) {
  (0, _inherits2["default"])(RouterContent, _PureComponent2);

  function RouterContent() {
    (0, _classCallCheck2["default"])(this, RouterContent);
    return (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(RouterContent).apply(this, arguments));
  }

  (0, _createClass2["default"])(RouterContent, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      (0, _utils.setRoutes)(this.props.defaultRoutes);
    }
  }, {
    key: "render",
    value: function render() {
      return _react["default"].createElement(_reactRouterDom.Router, {
        history: _history["default"]
      }, getRoutes(this.props.routes, undefined, this.props.isTabRouter));
    }
  }]);
  return RouterContent;
}(_react.PureComponent)) || _class);
/**
 * 全局组件
 */

var Fragment = (_dec2 = (0, _state.reduxConnect)(function () {
  return {
    fragmentList: (0, _state.getFrameState)().fragmentList
  };
}), _dec2(_class2 =
/*#__PURE__*/
function (_PureComponent3) {
  (0, _inherits2["default"])(Fragment, _PureComponent3);

  function Fragment() {
    (0, _classCallCheck2["default"])(this, Fragment);
    return (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(Fragment).apply(this, arguments));
  }

  (0, _createClass2["default"])(Fragment, [{
    key: "render",
    value: function render() {
      return _react["default"].createElement(_react["default"].Fragment, null, this.props.fragmentList);
    }
  }]);
  return Fragment;
}(_react.PureComponent)) || _class2);
/**
 * 获取路由配置
 * @param routes
 * @param indexPath
 * @param isTab
 * @returns {*}
 */

function getRoutes(routes, indexPath, isTab) {
  if (!routes) {
    return;
  }

  if (isTab) {
    return _react["default"].createElement(_TabRouter["default"], {
      options: routes
    });
  }

  return _react["default"].createElement(_reactRouterDom.Switch, null, routes.map(function (route) {
    var routePath = route.path,
        _route$component = route.component,
        RouteComponent = _route$component === void 0 ? 'div' : _route$component,
        _route$children = route.children,
        children = _route$children === void 0 ? [] : _route$children,
        indexPath = route.indexPath;
    var props = {
      key: routePath,
      path: routePath
    };

    props.render = function (props) {
      return _react["default"].createElement(RouteComponent, props, children && children.length && getRoutes(children.map(function (childRoute) {
        return _objectSpread({}, childRoute, {
          path: (0, _path.pathJoin)(routePath, childRoute.path)
        });
      }), indexPath && (0, _path.pathJoin)(routePath, indexPath), route.isTab));
    };

    return _react["default"].createElement(_reactRouterDom.Route, props);
  }), indexPath ? _react["default"].createElement(_reactRouterDom.Route, {
    render: function render() {
      return _history["default"].push(indexPath);
    },
    exact: true,
    key: "redirectRoute",
    path: "/"
  }) : '');
}