"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("antd/lib/tabs/style");

var _tabs = _interopRequireDefault(require("antd/lib/tabs"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _index = _interopRequireDefault(require("./index.less"));

var _wangctUtil = require("wangct-util");

var _state = require("../../utils/state");

var _Router = require("../Router");

var _dec, _class;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var TabRouter = (
/**
 * 选项卡路由器
 */
_dec = (0, _state.reduxConnect)(function () {
  return {
    pathname: (0, _state.getPathname)()
  };
}), _dec(_class =
/*#__PURE__*/
function (_PureComponent2) {
  (0, _inherits2["default"])(TabRouter, _PureComponent2);

  function TabRouter() {
    (0, _classCallCheck2["default"])(this, TabRouter);
    return (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf3["default"])(TabRouter).apply(this, arguments));
  }

  (0, _createClass2["default"])(TabRouter, [{
    key: "getOptions",
    value: function getOptions() {
      return (0, _wangctUtil.toAry)(this.props.options);
    }
  }, {
    key: "getActiveKey",
    value: function getActiveKey() {
      var options = this.getOptions();
      var target = options[this.getActiveIndex()];
      return target && target.path;
    }
  }, {
    key: "getActiveIndex",
    value: function getActiveIndex() {
      var options = this.getOptions();
      var pathname = this.props.pathname;
      return options.findIndex(function (opt) {
        return pathname.startsWith(opt.path);
      });
    }
  }, {
    key: "render",
    value: function render() {
      var activeIndex = this.getActiveIndex();
      return _react["default"].createElement(_tabs["default"], {
        className: _index["default"].container,
        activeKey: this.getActiveKey()
      }, this.getOptions().map(function (opt, index) {
        return _react["default"].createElement(_tabs["default"].TabPane, {
          key: opt.path,
          tab: opt.path
        }, _react["default"].createElement(TabComMod, {
          route: opt,
          destroy: index > activeIndex
        }));
      }));
    }
  }]);
  return TabRouter;
}(_react.PureComponent)) || _class);
exports["default"] = TabRouter;

var TabComMod =
/*#__PURE__*/
function (_PureComponent) {
  (0, _inherits2["default"])(TabComMod, _PureComponent);

  function TabComMod() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, TabComMod);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(TabComMod)).call.apply(_getPrototypeOf2, [this].concat(args)));
    _this.state = {
      hide: false
    };
    return _this;
  }

  (0, _createClass2["default"])(TabComMod, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState, snapshot) {
      this.checkDestroy(prevProps);
    }
  }, {
    key: "checkDestroy",
    value: function checkDestroy(prevProps) {
      var _this2 = this;

      if (prevProps.destroy !== this.props.destroy) {
        if (this.props.destroy) {
          setTimeout(function () {
            _this2.setState({
              hide: true
            });
          }, 300);
        } else {
          this.setState({
            hide: false
          });
        }
      }
    }
  }, {
    key: "getData",
    value: function getData() {
      return this.props.route || {};
    }
  }, {
    key: "render",
    value: function render() {
      if (this.state.hide) {
        return null;
      }

      var _this$getData = this.getData(),
          Com = _this$getData.component,
          children = _this$getData.children,
          routePath = _this$getData.path,
          indexPath = _this$getData.indexPath,
          isTab = _this$getData.isTab;

      return _react["default"].createElement(Com, null, children && children.length && (0, _Router.getRoutes)(children.map(function (childRoute) {
        return _objectSpread({}, childRoute, {
          path: (0, _wangctUtil.pathJoin)(routePath, childRoute.path)
        });
      }), indexPath && (0, _wangctUtil.pathJoin)(routePath, indexPath), isTab));
    }
  }]);
  return TabComMod;
}(_react.PureComponent);