"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  render: true,
  history: true
};
exports.render = render;
Object.defineProperty(exports, "history", {
  enumerable: true,
  get: function get() {
    return _history2["default"];
  }
});

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _interopRequireWildcard2 = _interopRequireDefault(require("@babel/runtime/helpers/interopRequireWildcard"));

require("./styles/global.less");

var _react = _interopRequireDefault(require("react"));

var _reactDom = require("react-dom");

var _models = _interopRequireDefault(require("./models"));

var _utils = require("./utils/utils");

Object.keys(_utils).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _utils[key];
    }
  });
});

var _store = require("./modules/store");

var _state = require("./utils/state");

Object.keys(_state).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _state[key];
    }
  });
});

var _Router = _interopRequireDefault(require("./components/Router"));

var _history2 = _interopRequireDefault(require("./modules/history"));

var _request = require("./utils/request");

Object.keys(_request).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _request[key];
    }
  });
});

var _path = require("./utils/path");

Object.keys(_path).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _path[key];
    }
  });
});

/**
 * 渲染方法
 */
function render() {
  var elem = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'root';
  var routesPro = Promise.resolve().then(function () {
    return (0, _interopRequireWildcard2["default"])(require('./config/routes'));
  }).then(function (mod) {
    return mod["default"];
  });
  var modelsPro = Promise.resolve().then(function () {
    return (0, _interopRequireWildcard2["default"])(require('./config/models'));
  }).then(function (mod) {
    return mod["default"];
  });
  return Promise.all([routesPro, modelsPro]).then(function (_ref) {
    var _ref2 = (0, _slicedToArray2["default"])(_ref, 2),
        routes = _ref2[0],
        models = _ref2[1];

    elem = (0, _utils.getElem)(elem);
    var store = (0, _store.getStore)([].concat((0, _toConsumableArray2["default"])(models), (0, _toConsumableArray2["default"])(_models["default"])));
    (0, _state.setStore)(store);
    (0, _reactDom.render)(_react["default"].createElement(_Router["default"], {
      store: store,
      routes: routes
    }), elem);
  });
}