"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getFrameState = getFrameState;
exports.getPathname = getPathname;
exports.setStore = setStore;
exports.getStore = getStore;
exports.getState = getState;
exports.reduxConnect = reduxConnect;

var _reactRedux = require("react-redux");

var _utils = require("./utils");

var _dic = require("../json/dic");

/**
 * 获取框架state
 * @returns {*|{}}
 */
function getFrameState() {
  return getState()[_dic.Fields.globalNamespace] || {};
}
/**
 * 获取路径
 * @returns {*|{}}
 */


function getPathname() {
  return getFrameState().pathname;
}
/**
 * 设置store
 * @param store
 */


function setStore(store) {
  return (0, _utils.setGlobalConfig)('store', store);
}
/**
 * 获取store
 * @returns {{}}
 */


function getStore() {
  return (0, _utils.getGlobalConfig)('store');
}
/**
 * 获取state
 * @returns {S | S | any | Promise<NavigationPreloadState>}
 */


function getState() {
  return getStore().getState();
}
/**
 * connect别名
 * @param args
 */


function reduxConnect() {
  return _reactRedux.connect.apply(void 0, arguments);
}